> For the complete documentation index, see [llms.txt](https://docs.hex-rays.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hex-rays.com/core/disassembler/disassembly-gallery/java-bytecode.md).

# Java Bytecode

Assembler code

```
// Segment type: Pure code
  public synchronized void reset()
  max_stack 4
  max_locals 2
  {
    invokestatic java.security.IdentityScope.getSystemScope()
                                               // CODE XREF: <init>+5↑P
    astore_1 // met004_slot001
    aload_1 // met004_slot001
    instanceof sun.security.provider.IdentityDatabase
    ifeq met004_47
    aload_0 // met004_slot000
    aload_1 // met004_slot001
    checkcast sun.security.provider.IdentityDatabase
    putfield scope
    aload_0 // met004_slot000
    new java.lang.StringBuffer
    dup
    ldc "installing "
    invokespecial java.lang.StringBuffer.<init>(java.lang.String)
    aload_1 // met004_slot001
    invokevirtual java.lang.StringBuffer.append(java.lang.Object)
    ldc " as the scope for signers."
    invokevirtual java.lang.StringBuffer.append(java.lang.String)
    invokevirtual java.lang.StringBuffer.toString()
    invokevirtual debug(java.lang.String)
    goto met004_53

met004_47:                                     // CODE XREF: reset+8↑j
    aload_0 // met004_slot000
    ldc "no signer scope found."
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.hex-rays.com/core/disassembler/disassembly-gallery/java-bytecode.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
